Subject: [bug#69328] [PATCH 00/12] Better source code recovery from SWH

From: Timothy Sample <[email-masked]>
Date: Sat, 02 Mar 2024 22:54:22 -0600

Ludovic Courtès <[email-masked]> writes:

> Hello Guix!
>
> This patch series improves source code recovery from SWH, as a followup
> to <https://issues.guix.gnu.org/68741>.
>
> It does several things:
>
>   • ‘guix lint -c archival’ now emits save requests for VCSes other
>     than Git.
>
>   • Fix <https://issues.guix.gnu.org/69070>.
>
>   • Allow content-addressed recovery of Mercurial and Subversion
>     checkouts.
>
>   • Allow Bazaar recovery using ‘download-nar’ (I didn’t bother with SWH).
>
>   • Have all these things honor the ‘GUIX_DOWNLOAD_SEQUENCE’ environment
>     variable.

Very nice!  I like the design of ‘GUIX_DOWNLOAD_SEQUENCE’ compared to
‘GUIX_DOWNLOAD_FALLBACK_TEST’, but I’m not sure about the name (sorry
for bike shedding!).  In particular, the “sequences” ‘(nar swh)’ and
‘(swh nar)’ will both try ‘nar’ first and then ‘swh’.  What about
“methods” or “strategies” or something?

> You can try the various methods like this:
>
>   GUIX_DOWNLOAD_SEQUENCE=nar ./pre-inst-env guix build -S apl --check
>   GUIX_DOWNLOAD_SEQUENCE=swh ./pre-inst-env guix build -S guile-wisp --check
>   GUIX_DOWNLOAD_SEQUENCE=swh ./pre-inst-env guix build -S guile-gcrypt --check

I tried

  GUIX_DOWNLOAD_SEQUENCE=disarchive ./pre-inst-env guix build -S mes --check

and it worked like a charm.

> Feedback welcome!

Other than the name and the little separate comment on the last patch,
this all LGTM.

-- Tim